Type
object

Specification

PropertyTypeDescription
specobject

Configuration affecting edge load balancer. See more details at: https://istio.io/docs/reference/config/networking/gateway.html

statusobject

.spec

Description
Configuration affecting edge load balancer. See more details at: https://istio.io/docs/reference/config/networking/gateway.html
Type
object
PropertyTypeDescription
selectorobject
serversarray

A list of server specifications.

.spec.selector

Type
object

.spec.servers

Description
A list of server specifications.
Type
array

.spec.servers[]

Type
object
PropertyTypeDescription
bindstring
defaultEndpointstring
hostsarray

One or more hosts exposed by this gateway.

namestring

An optional name of the server, when set must be unique across all servers.

portobject
tlsobject

Set of TLS related options that govern the server's behavior.

.spec.servers[].hosts

Description
One or more hosts exposed by this gateway.
Type
array

.spec.servers[].hosts[]

Type
string

.spec.servers[].port

Type
object
PropertyTypeDescription
namestring

Label assigned to the port.

numberinteger

A valid non-negative integer port number.

protocolstring

The protocol exposed on the port.

targetPortinteger

.spec.servers[].tls

Description
Set of TLS related options that govern the server's behavior.
Type
object
PropertyTypeDescription
caCertificatesstring

REQUIRED if mode is MUTUAL.

cipherSuitesarray

Optional: If specified, only support the specified cipher list.

credentialNamestring
httpsRedirectboolean
maxProtocolVersionstring

Optional: Maximum TLS protocol version.

minProtocolVersionstring

Optional: Minimum TLS protocol version.

modestring
privateKeystring

REQUIRED if mode is SIMPLE or MUTUAL.

serverCertificatestring

REQUIRED if mode is SIMPLE or MUTUAL.

subjectAltNamesarray
verifyCertificateHasharray
verifyCertificateSpkiarray

.spec.servers[].tls.cipherSuites

Description
Optional: If specified, only support the specified cipher list.
Type
array

.spec.servers[].tls.cipherSuites[]

Type
string

.spec.servers[].tls.subjectAltNames

Type
array

.spec.servers[].tls.subjectAltNames[]

Type
string

.spec.servers[].tls.verifyCertificateHash

Type
array

.spec.servers[].tls.verifyCertificateHash[]

Type
string

.spec.servers[].tls.verifyCertificateSpki

Type
array

.spec.servers[].tls.verifyCertificateSpki[]

Type
string

.status

Type
object

API Endpoints

The following API endpoints are available:

  • /apis/networking.istio.io/v1alpha3/namespaces/{namespace}/gateways
    • DELETE: delete collection of Gateway
    • GET: list objects of kind Gateway
    • POST: create a new Gateway
  • /apis/networking.istio.io/v1alpha3/namespaces/{namespace}/gateways/{name}
    • DELETE: delete the specified Gateway
    • GET: read the specified Gateway
    • PATCH: partially update the specified Gateway
    • PUT: replace the specified Gateway
  • /apis/networking.istio.io/v1alpha3/namespaces/{namespace}/gateways/{name}/status
    • GET: read status of the specified Gateway
    • PATCH: partially update status of the specified Gateway
    • PUT: replace status of the specified Gateway

/apis/networking.istio.io/v1alpha3/namespaces/{namespace}/gateways

HTTP method
DELETE
Description
delete collection of Gateway
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind Gateway
HTTP responses
HTTP codeResponse body
200 - OKGatewayList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new Gateway
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyGateway schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKGateway schema
201 - CreatedGateway schema
202 - AcceptedGateway schema
401 - UnauthorizedEmpty

/apis/networking.istio.io/v1alpha3/namespaces/{namespace}/gateways/{name}

HTTP method
DELETE
Description
delete the specified Gateway
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified Gateway
HTTP responses
HTTP codeResponse body
200 - OKGateway schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified Gateway
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKGateway schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified Gateway
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyGateway schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKGateway schema
201 - CreatedGateway schema
401 - UnauthorizedEmpty

/apis/networking.istio.io/v1alpha3/namespaces/{namespace}/gateways/{name}/status

HTTP method
GET
Description
read status of the specified Gateway
HTTP responses
HTTP codeResponse body
200 - OKGateway schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified Gateway
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKGateway schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified Gateway
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyGateway schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKGateway schema
201 - CreatedGateway schema
401 - UnauthorizedEmpty